#PBForms Created
'--------------------------------------------------------------------------------
' The first line in this file is a PBForms metastatement.
' It should ALWAYS be the first line of the file. Other
' PBForms metastatements are placed at the beginning and
' ending of blocks of code that should be edited using
' PBForms only. Do not edit or delete these
' metastatements or PBForms will not be able to reread
' the file correctly. See the PBForms documentation for
' more information.
' Beginning blocks begin like this: #PBForms Begin ...
' Ending blocks begin like this:    #PBForms End ...
' Other PBForms metastatements such as:
'     #PBForms Declarations
' are used to tell PBForms where to insert additional
' code. Feel free to make changes anywhere else in the file.
'--------------------------------------------------------------------------------

#Compile Exe
#Dim All

'--------------------------------------------------------------------------------
'   ** Includes **
'--------------------------------------------------------------------------------
#PBForms Begin Includes
#If Not %Def(%WINAPI)
    #Include "WIN32API.INC"
#EndIf
#Include "PBForms.INC"
#PBForms End Includes
'--------------------------------------------------------------------------------

'--------------------------------------------------------------------------------
'   ** Constants **
'--------------------------------------------------------------------------------
#PBForms Begin Constants
%IDD_Form1                  = 101
%IDC_chkDefExamples         = 1001
%IDC_chkExprEvalExamples    = 1002
%IDC_txtPlotEq              = 1003
%IDC_btnPlot                = 1004
%IDC_Picture1               = 1005
%IDC_txtSumMax              = 1006
%IDC_btnSum                 = 1007
%IDC_txtSumResult           = 1008
%IDC_txtSumExpression       = 1009
%IDC_btnDefine              = 1010
%IDC_txtDefinition          = 1011
%IDC_btnEval                = 1012
%IDC_txtResult              = 1013
%IDC_txtExpression          = 1014
%IDC_lblSumResult           = 1015
%IDC_lblSumExpression       = 1016
%IDC_Label2                 = 1017
%IDC_lblSpeedTest           = 1018
%IDC_lbl_UserDef            = 1019
%IDC_lbl_ExprEval           = 1020
%IDC_lblElapsed             = 1021
%IDC_Label1                 = 1022
%IDC_lblDefineSource2       = 1023
%IDC_lblDefineSource        = 1024
%IDC_lblDefinition          = 1025
%IDC_lblEvalSource2         = 1026
%IDC_lblEvalSource          = 1027
%IDC_lblResult              = 1028
%IDC_lblExpression          = 1029
%IDC_lblFPU                 = 1030
%IDC_chkInvalidOp           = 1031
%IDC_chkDenormalOp          = 1032
%IDC_chkDivisionBy0         = 1033
%IDC_chkOverflow            = 1034
%IDC_chkUnderflow           = 1035
%IDC_chkPrecisionLoss       = 1036
#PBForms End Constants
'--------------------------------------------------------------------------------

'--------------------------------------------------------------------------------
'   ** Declarations **
'--------------------------------------------------------------------------------
Declare CallBack Function ShowForm1Proc()
Declare Function ShowForm1(ByVal hParent As Dword) As Long
#PBForms Declarations
'--------------------------------------------------------------------------------

'--------------------------------------------------------------------------------
#Include "uCalcPB.bas"

Global Ps As PAINTSTRUCT
Global Rct As RECT

Sub SpeedTest(ByVal hDlg As Dword)
   Dim Expression As String, txtSumMax As String
   Dim ExprHandle As Dword, xHandle As Dword
   Dim x As Extended, SumTotal As Extended, SumMax As Extended
   Dim TimerStart As Single, TimerEnd As Single

   Control Get Text hDlg, %IDC_txtSumExpression To Expression
   Control Get Text hDlg, %IDC_txtSumMax To txtSumMax

   xHandle = ucDefineVariable("x", VarPtr(x))
   ExprHandle = ucParse(Expression)

   SumMax = Val(txtSumMax)
   TimerStart = Timer

   For x = 1 To SumMax
      SumTotal = SumTotal + ucEvaluate(ExprHandle)
   Next

   TimerEnd = Timer - TimerStart
   Control Set Text hDlg, %IDC_txtSumResult, Str$(SumTotal, 18)
   Control Set Text hDlg, %IDC_lblElapsed, "Elapsed Time: " + Format$(TimerEnd, "0.00") + " seconds"

   ucReleaseItem ExprHandle
   ucReleaseItem xHandle
End Sub

Sub CartesianLineTo(ByVal hDc As Long, ByVal x As Single, y As Single)
   Dim NewX As Long, NewY As Long

   NewX = 205 * (x + 10) / 20
   NewY = 100 * (2 - y) / 4

   If x = -10 Or NewY > 99 Or NewY < 0 _
   Then MoveToEx hDc, NewX, Min&(Max&(NewY, 0), 99), ByVal %NULL _
   Else LineTo hDc, NewX, NewY
End Sub

Sub PlotGraph(ByVal hDlg As Dword)
    Dim x As Extended, EqHandle As Dword, xHandle As Dword
    Dim Equation$
    Dim hDc As Dword

    hDC = GetDC(GetDlgItem(hDlg, %IDC_Picture1))
    Rct.nRight = 205 : Rct.nBottom = 100
    FillRect hDC, Rct, 1

    Control Get Text hDlg, %IDC_txtPlotEq To Equation$

    xHandle = ucDefineVariable("x", VarPtr(x))
    EqHandle = ucParse(Equation$)

    For x = -10 To 10 Step 0.125
       CartesianLineTo hDc, x, ucEvaluate(EqHandle)
    Next

    ucReleaseItem EqHandle
    ucReleaseItem xHandle

    ReleaseDC GetDlgItem(hDlg, %IDC_Picture1), hDC
End Sub

' uCalc callback routines

Function MyErrorHandler(ByVal t As Long) As Long
   Static AlreadyDisplayedOnce As Long

   If AlreadyDisplayedOnce = %ucFalse Then
      MsgBox "Error Handler message: " + ucErrorMessage(0, t) + Chr$(13) _
         + "Offending symbol: " + ucErrSymbol(t) + Chr$(13) _
         + "Error Location: " + Str$(ucErrLocation(t)) + Chr$(13) + Chr$(13) _
         + "This message box won't be displayed for the next error." + Chr$(13) _
         + "Remove 'AlreadyDisplayedOnce = %ucTrue' in the demo source code to change this."
   End If

   ' Remove the line below if you want the message box to be
   ' displayed every time there's an error.
   AlreadyDisplayedOnce = %ucTrue
   MyErrorHandler = %ucAbort
End Function

Sub MyArea(ByVal Expr As ucExpression)
   Dim MyLength As Extended, MyWidth As Extended

   MyLength = ucParam(Expr, 1)
   MyWidth = ucParam(Expr, 2)

   If MyLength < 0 Then ucRaiseErrorMessage Expr, "Length cannot be negative"
   If MyWidth < 0 Then ucRaiseErrorMessage Expr, "Width cannot be negative"

   ucReturn(Expr, MyLength * MyWidth)
End Sub

Function NonNativeFunc(ByVal a As Double, ByRef b As Long, ByVal c As Byte) As Extended
   NonNativeFunc = a + b + c
End Function

Sub MyIIF_Numeric(ByVal Expr As ucExpression)
   Dim Condition As Extended, TruePart As Dword, FalsePart As Dword

   Condition = ucParam(Expr, 1)
   TruePart = ucParamHandle(Expr, 2)
   FalsePart = ucParamHandle(Expr, 3)

   If Condition <> 0 Then
      ucReturn(Expr, ucEvaluate(TruePart))
   Else
      ucReturn(Expr, ucEvaluate(FalsePart))
   End If
End Sub

Sub MyIIF_String(ByVal Expr As ucExpression)
   Dim Condition As Extended, TruePart As Dword, FalsePart As Dword

   Condition = ucParam(Expr, 1)
   TruePart = ucParamHandle(Expr, 2)
   FalsePart = ucParamHandle(Expr, 3)

   If Condition <> 0 Then
      ucReturnStr(Expr, ucEvaluateStr(TruePart))
   Else
      ucReturnStr(Expr, ucEvaluateStr(FalsePart))
   End If
End Sub

Sub Native_MsgBox(ByVal Expr As ucExpression)
   ucReturn(Expr, MsgBox(ucParamStr(Expr, 1), ucParam(Expr, 2), ucParamStr(Expr, 3)))
End Sub

Function nn_MsgBox(ByRef Prompt As String, ByVal Buttons As Long, ByRef Title As String) As Long
   nn_MsgBox = MsgBox(Prompt, Buttons, Title)
End Function

Sub MyAverage(ByVal Expr As ucExpression)
   Dim x As Long, Total As Extended

   For x = 1 To ucParamCount(Expr)
      Total = Total + ucParam(Expr, x)
   Next

   ucReturn(Expr, Total / ucParamCount(Expr))
End Sub

Sub MyLeft(ByVal Expr As ucExpression)
    ucReturnStr(Expr, Left$(ucParamStr(Expr, 1), ucParam(Expr, 2)))
End Sub

Sub StringRepeat(ByVal Expr As ucExpression)
   Dim x As Long, TotalString As String

   For x = 1 To ucParam(Expr, 2)
      TotalString = TotalString + ucParamStr(Expr, 1)
   Next

   ucReturnStr(Expr, TotalString)
End Sub

Sub ucSum(ByVal Expr As ucExpression)
   Dim Expression As Dword, VarHandle As Dword
   Dim Start As Long, Finish As Long, sStep As Long
   Dim x As Extended, Total As Extended

   Expression = ucParamHandle(Expr, 1)
   Start      = ucParam(Expr, 2)
   Finish     = ucParam(Expr, 3)
   sStep      = ucParam(Expr, 4)
   VarHandle  = ucParamHandle(Expr, 5)

   For x = Start To Finish Step sStep
      ucSetVariableValue(VarHandle, x)
      Total = Total + ucEvaluate(Expression)
   Next

   ucReturn(Expr, Total)
End Sub

Sub ucSolve(ByVal Expr As ucExpression)
   Dim Expression As Dword, Variable As Dword, Iterations As Long
   Dim a As Double, b As Double, fa As Double, fb As Double
   Dim Value As Double, tmp As Double

   Expression = ucParamHandle(Expr, 1)
   a = ucParam(Expr, 2)
   b = ucParam(Expr, 3)
   Variable = ucParamHandle(Expr, 4)

   ucSetVariableValue(Variable, a): fa = ucEvaluate(Expression)
   ucSetVariableValue(Variable, b): fb = ucEvaluate(Expression)

   If fb < fa Then tmp = a: a = b: b = tmp   'swap a, b

   Do While Abs(b - a) > 0.000000000000001
      ucSetVariableValue(Variable, (a + b) / 2)

      Value = ucEvaluate(Expression)

      If Value = 0 Then a = (a + b) / 2: Exit Do

      If Value < 0 _
      Then a = (a + b) / 2 _
      Else b = (a + b) / 2

      Iterations = Iterations + 1
      If Iterations = 100 Then Exit Do
   Loop

   If Abs(Value) > 0.0000000001 Then ucRaiseErrorMessage Expr, "Solution not found"

   ucReturn(Expr, a)
End Sub

Sub Test(ByVal Expr As String, ByVal Answer As String, Optional ByVal t As Long)
   If Answer <> ucEvalStr(Expr, t) Then MsgBox Expr + Chr$(10) + ucEvalStr(Expr, t) + Chr$(10) + Answer
End Sub

Sub TestExpand(ByVal Expr As String, ByVal Answer As String, Optional ByVal t As Long)
   If Answer <> ucExpand(Expr, t) Then MsgBox Expr + Chr$(10) + ucExpand(Expr, t) + Chr$(10) + Answer
End Sub

Function PBMain()
   ' The definitions here are for "callback" routines.
   ' Note: A callback in uCalc has a somewhat different meaning than a callback in PB.
   ' Each line ends with the address of a routine, using CodePtr.
   ' The actual code for these routines can be found elsewhere in this file.
   ' Do a search for MyErrorHandler, for instance, to see the actual code for it.

   ' The MyErrorHandler() function will be called whenever and wherever an
   ' error (such as "Syntax Error") is raised.
   uCalc %uc_AddErrorHandler, 0, CodePtr(MyErrorHandler)

   ' Native callback definitions, which start with "Native: " are recommended for
   ' speed, and for routines that use uCalc's default numeric and string types.
   ' MyArea() returns the product of multiplying the two arguments.
   ' MyLeft() returns the left-most characters of a string.  The second argument represents the number of characters.
   ' MsgBox() displays a message box.  The 1st argument is required.  The others are optional.
   ucDefineFunction "Native: MyArea(Length, Width)", CodePtr(MyArea)
   ucDefineFunction "Native: MyLeft(Text As String, Count) As String", CodePtr(MyLeft)
   ucDefineFunction "Native: MsgBox(Prompt As String, Buttons = 0, Title As String = 'uCalc')", CodePtr(Native_MsgBox)

   ' The three consecutive dots "..." mean that MyAverage can take any number of arguments
   ' (however, because "x" is specified, there must be at least one argument).
   ucDefineFunction "Native: MyAverage(x ...)", CodePtr(MyAverage)

   ' Two versions of MyIIF can co-exist peacefully with the same name because
   ' they are defined with different argument types (numeric vs string).
   ' By passing the last two arguments ByExpr, the callback can chose to evaluate only one of of them.
   ucDefineFunction "Native: MyIIf(cond, ByExpr TruePart, ByExpr FalsePart)", CodePtr(MyIIF_Numeric)
   ucDefineFunction "Native: MyIIf(cond, ByExpr TruePart As String, ByExpr FalsePart As String) As String", CodePtr(MyIIF_String)

   ' The following defines the "*" operator so that MyString * n returns MyString repeated n times.
   ' For instance, "He " * 3, would return "He He He".  20 represents the precedence level.  It is
   ' arbitrarily set at the same level as that of the "*" multiplication operator defined in uCalcPB.Bas.
   ucDefineOperator "Native: 20 {MyString As String} * {Number} As String", CodePtr(StringRepeat)

   ' Non-native callbacks are intended for routines that were not created with
   ' uCalc in mind, such as the Windows API, or other pre-existing DLL routines.
   ' It is convenient (no need to adapt the routines; all you need is a function
   ' address), but not as fast as Native callbacks.
   ' NonNativeFunc() simply adds the three arguments.
   ' nn_MsgBox is a Non-Native version of MsgBox, which displays a message box.
   ucDefineFunction "NonNativeFunc(ByVal a As Double, ByRef b As Long, ByVal c As Byte) As Extended", CodePtr(NonNativeFunc)
   ucDefineFunction "nn_MsgBox(ByRef Prompt As String, ByVal Buttons As Long = 0, ByRef Title As String = 'uCalc') As Long", CodePtr(nn_MsgBox)

   ' This definition is for a summation.  See the callback ucSum() routine for the
   ' actual code, which runs a loop that adds up the total for the expression in
   ' the first argument a number of times based on the second and third arguments.
   ' For instance Sum(g^2+1, 1, 5, 1, g) returns 60 and Sum(x^2, 1, 10) returns 385.
   ' The last two arguments are optional, so they default to 1 and x if omitted.
   '
   ' The first argument is passed "ByExpr".  So instead of being evaluated before
   ' being passed to the callback the way an ordinary argument would be, a handle
   ' for the expression is passed so that the callback can evaluate it (in this
   ' case numerous times).
   '
   ' The last argument is passed "ByHandle".  This causes the callback to receive
   ' a handle for the variable being passed, in such a way that it can be linked to
   ' the summation counter, and integrated into the expression in the first argument.
   '
   ' The actual function being defined is Sum_().  Then a syntax construct named
   ' Sum() is defined in such a way that the last argument gets defined as a local
   ' variable.  So if you evaluate Sum(x^2, 5, 10, 1, x), the local "x" in this
   ' expression will not interfere with a pre-existing variable named x.  Also you
   ' do not need to declare a variable ahead of time to use it as a counter for Sum().
   ucDefineFunction "Native: Sum_(ByExpr Expr, Start, Finish, Step, ByHandle Var)", CodePtr(ucSum)
   ucDefineSyntax "Sum({Expr}, {Start}, {Finish} [, {Step=1} [, {Var=x}]])" _
                + "::= Local({Var}, Sum_({Expr}, {Start}, {Finish}, {Step}, {Var}))"

   ' The following routine solves an equation.
   ' The callback code is based on the Bisection Method algorithm.
   ' The concept here is very similar to that of Sum().
   ' Two syntax constructs are defined.  The second one rearranges the equation
   ' if it includes an equal sign.
   ' For instance Solve(x^2 = 9+x) becomes Solve(x^2 - (9+x))
   ' Solve(x^2 + 1 = 26) returns 5.
   ' Solve(x^2 + 1 = 26, -1000, 0) returns -5.
   ucDefineFunction "Native: Solve_(ByExpr Expr, a, b, ByHandle Var)", CodePtr(ucSolve)
   ucDefineSyntax "Solve({Expr} [, {a=-100000000} [, {b=100000000} [, {Var=x}]]]) " _
                + "::= Local({Var}, Solve_({Expr}, {a}, {b}, {Var}))"
   ucDefineSyntax "Solve({Left} = {Right} [, {etc}]) ::= Solve({Left}-({Right}) {etc: , {etc}})"

   ShowForm1 %HWND_DESKTOP
End Function
'--------------------------------------------------------------------------------

'--------------------------------------------------------------------------------
'   ** CallBacks **
'--------------------------------------------------------------------------------
CallBack Function ShowForm1Proc()
    Dim txt$, Discard As Long

    Select Case CbMsg
        Case %WM_COMMAND
            Select Case CbCtl
                Case %IDC_txtExpression
                   Control Get Text CbHndl, %IDC_txtExpression To txt$
                   Control Set Text CbHndl, %IDC_lblEvalSource, "Expression = """ + txt$ + """"
                Case %IDC_txtDefinition
                   Control Get Text CbHndl, %IDC_txtDefinition To txt$
                   Control Set Text CbHndl, %IDC_lblDefineSource, "Definition = """ + txt$ + """"
                Case %IDC_btnEval
                    If CbCtlMsg = %BN_CLICKED Then
                       ' ucEval() evaluates an expression and returns a numeric result.
                       ' ucEvalStr() can evaluate expressions of any data type (numeric, string, or other).
                       ' If the result is numeric ucEvalStr conveniently converts it to a string for you.
                       Control Get Text CbHndl, %IDC_txtExpression To txt$
                       Control Set Text CbHndl, %IDC_txtResult, ucEvalStr(txt$)
                    End If
                Case %IDC_btnDefine
                    If CbCtlMsg = %BN_CLICKED Then
                       Control Get Text CbHndl, %IDC_txtDefinition To txt$

                       ' ucDefine can define a variable, function, operator, syntax construct,
                       ' constant, pattern, data type, and more.
                       '
                       ' Examples:
                       '
                       ' ucDefine "Var: MyVariable As String"
                       ' ucDefine "Func: Area(Length, Width) = Length * Width"
                       ' ucDefine "Op: 50 {x}%  :=  x / 100"   ' 50 is an arbitrary precedence level.
                       ' ucDefine "Syntax: {a} + {a} ::= 'Two {a}s are better than one {a}'"
                       ' ucDefine "Const: Pi = Atan(1) * 4"
                       ucDefine txt$
                    End If
                Case %IDC_btnSum
                    If CbCtlMsg = %BN_CLICKED Then
                       Call SpeedTest(CbHndl)
                    End If
                Case %IDC_btnPlot
                    If CbCtlMsg = %BN_CLICKED Then
                        Call PlotGraph(CbHndl)
                    End If
                Case %IDC_chkExprEvalExamples
                   Discard = Shell(Environ$("Comspec") + " /C NotePad DemoExpr.Txt")
                Case %IDC_chkDefExamples
                   Discard = Shell(Environ$("Comspec") + " /C NotePad DemoDefs.Txt")
                Case %IDC_chkInvalidOp
                   ' If toggled, then an expression such as 0 / 0 raises an error.
                   ' If toggled again, then 0 / 0 returns NaN.
                   uCalc %uc_ToggleFPU, 0, %uc_FPU_Mask_InvalidOp
                Case %IDC_chkDenormalOp
                   uCalc %uc_ToggleFPU, 0, %uc_FPU_Mask_DenormalOp
                Case %IDC_chkDivisionBy0
                   ' If toggled, then 1 / 0 raises an error.
                   ' If toggled again, then 1 / 0 returns Inf.
                   uCalc %uc_ToggleFPU, 0, %uc_FPU_Mask_ZeroDivide
                Case %IDC_chkOverflow
                   ' If toggled, then 100! ^ 150 raises an error.
                   ' If toggled again, then 100! ^ 150 returns Inf.
                   uCalc %uc_ToggleFPU, 0, %uc_FPU_Mask_Overflow
                Case %IDC_chkUnderflow
                   ' If toggled, then (1/100!)^150 raises an error.
                   ' If toggled again, then (1/100!)^150 returns 0.
                   uCalc %uc_ToggleFPU, 0, %uc_FPU_Mask_Underflow
                Case %IDC_chkPrecisionLoss
                   ' If toggled, an expression that cannot be represented in exact form
                   ' such as "1/3" will raise an error.
                   ' If toggled again, "1/3" returns the closest extended precision approximation.
                   uCalc %uc_ToggleFPU, 0, %uc_FPU_Mask_PrecisionLoss
            End Select
    End Select

End Function
'--------------------------------------------------------------------------------

'--------------------------------------------------------------------------------
'   ** Dialogs **
'--------------------------------------------------------------------------------
Function ShowForm1(ByVal hParent As Dword) As Long
    Local lRslt As Long
#PBForms Begin Dialog %IDD_Form1->->
    Local hDlg As Dword
    Local hFont1 As Dword
    Local hFont2 As Dword


    Dialog New hParent, "uCalc Fast Math Parser 2.96 PowerBASIC " + _
        "Demo", 153, 106, 430, 240, %WS_POPUP Or %WS_BORDER Or %WS_DLGFRAME Or _
        %WS_SYSMENU Or %WS_CLIPSIBLINGS Or %WS_CLIPCHILDREN Or %WS_VISIBLE Or _
        %DS_3DLOOK Or %DS_NOFAILCREATE Or %DS_SETFONT, %WS_EX_WINDOWEDGE Or _
        %WS_EX_CONTROLPARENT Or %WS_EX_APPWINDOW Or %WS_EX_LEFT Or _
        %WS_EX_LTRREADING Or %WS_EX_RIGHTSCROLLBAR, To hDlg
    Control Add TextBox, hDlg, %IDC_txtExpression, "3+4/5-8", 64, 30, 145, 11
    Control Add TextBox, hDlg, %IDC_txtDefinition, "Var: MyVariable = 1234.5", _
        272, 30, 139, 11
    Control Add TextBox, hDlg, %IDC_txtSumMax, "100000", 145, 150, 54, 12
    Control Add TextBox, hDlg, %IDC_txtSumExpression, "x^2+5*x-10", 60, 166, _
        139, 12
    Control Add TextBox, hDlg, %IDC_txtPlotEq, "-sin(x)/2", 268, 136, 139, 12
    Control Add Label, hDlg, %IDC_lblExpression, "User Expression:", 5, 30, 55, _
        10
    Control Add Label, hDlg, %IDC_lblResult, "Result:", 35, 45, 25, 11
    Control Add TextBox, hDlg, %IDC_txtResult, "", 64, 44, 145, 12
    Control Add Label, hDlg, %IDC_lblEvalSource, "Expression = ""3+4/5-8""", 64, _
        5, 139, 10
    Control Add Label, hDlg, %IDC_lblEvalSource2, "Result = " + _
        "ucEvalStr(Expression)", 64, 15, 139, 10
    Control Add Button, hDlg, %IDC_btnEval, "Evaluate", 64, 59, 38, 15
    Control Add Label, hDlg, %IDC_lblDefinition, "Definition:", 235, 30, 30, 10
    Control Add Button, hDlg, %IDC_btnDefine, "Define", 272, 44, 43, 16
    Control Add Label, hDlg, %IDC_lblDefineSource, "Definition = ""Var: " + _
        "MyVariable = 1234.5""", 272, 5, 139, 10
    Control Add Label, hDlg, %IDC_lblDefineSource2, "ucDefine Definition", 272, _
        15, 139, 10
    Control Add TextBox, hDlg, %IDC_txtSumResult, "", 60, 181, 139, 11
    Control Add Button, hDlg, %IDC_btnSum, "Start", 60, 195, 27, 16
    Control Add Label, hDlg, %IDC_Label1, "Summation from 1 to", 66, 153, 75, 7
    Control Add Label, hDlg, %IDC_lblElapsed, "Elapsed Time: 0 seconds", 97, _
        210, 102, 11
    Control Add Image, hDlg, %IDC_Picture1, "", 268, 151, 138, 62, %WS_CHILD Or _
        %WS_VISIBLE Or %WS_BORDER Or %SS_BITMAP Or %SS_CENTERIMAGE
    Control Add Button, hDlg, %IDC_btnPlot, "Plot", 266, 218, 33, 16
    Control Add Label, hDlg, %IDC_lbl_ExprEval, "Expression Evaluator", 107, 59, _
        100, 11
    Control Set Color hDlg, %IDC_lbl_ExprEval, RGB(8, 0, 0), RGB(192, 255, 192)
    Control Add Label, hDlg, %IDC_lbl_UserDef, "User Definitions", 325, 44, 76, _
        11
    Control Set Color hDlg, %IDC_lbl_UserDef, RGB(8, 0, 0), RGB(192, 255, 192)
    Control Add Label, hDlg, %IDC_lblSpeedTest, "Speed Test", 97, 195, 56, 12
    Control Set Color hDlg, %IDC_lblSpeedTest, RGB(8, 0, 0), RGB(192, 255, 192)
    Control Add Label, hDlg, %IDC_Label2, "Equation Plotter", 309, 218, 75, 11
    Control Set Color hDlg, %IDC_Label2, RGB(8, 0, 0), RGB(192, 255, 192)
    Control Add CheckBox, hDlg, %IDC_chkExprEvalExamples, "Show list of sample " + _
        "expressions", 107, 79, 118, 10
    Control Add CheckBox, hDlg, %IDC_chkDefExamples, "Show list of sample user " + _
        "definitions", 272, 64, 139, 10
    Control Add Label, hDlg, %IDC_lblSumExpression, "Expression:", 16, 168, 43, _
        10
    Control Add Label, hDlg, %IDC_lblSumResult, "Sum Result:", 16, 183, 40, 10
    Control Add Label, hDlg, %IDC_lblFPU, "FPU exception masks", 270, 85, 100, _
        10
    Control Add CheckBox, hDlg, %IDC_chkInvalidOp, "Invalid Op", 270, 95, 60, 10
    Control Add CheckBox, hDlg, %IDC_chkDenormalOp, "Denormal Op", 270, 105, 60, _
        10
    Control Add CheckBox, hDlg, %IDC_chkDivisionBy0, "Division By 0", 270, 115, _
        55, 10
    Control Add CheckBox, hDlg, %IDC_chkOverflow, "Overflow", 345, 95, 60, 10
    Control Add CheckBox, hDlg, %IDC_chkUnderflow, "Underflow", 345, 105, 60, 10
    Control Add CheckBox, hDlg, %IDC_chkPrecisionLoss, "Precision Loss", 345, _
        115, 60, 10

    hFont1 = PBFormsMakeFont("MS Sans Serif", 10, 700, %FALSE, %FALSE, %FALSE, %ANSI_CHARSET)
    hFont2 = PBFormsMakeFont("MS Sans Serif", 8, 400, %TRUE, %FALSE, %FALSE, %ANSI_CHARSET)

    Control Send hDlg, %IDC_lbl_ExprEval, %WM_SETFONT, hFont1, 0
    Control Send hDlg, %IDC_lbl_UserDef, %WM_SETFONT, hFont1, 0
    Control Send hDlg, %IDC_lblSpeedTest, %WM_SETFONT, hFont1, 0
    Control Send hDlg, %IDC_Label2, %WM_SETFONT, hFont1, 0
    Control Send hDlg, %IDC_lblFPU, %WM_SETFONT, hFont2, 0

#PBForms End Dialog

    Control Set Check hDlg, %IDC_chkInvalidOp, 1
    Control Set Check hDlg, %IDC_chkDenormalOp, 1
    Control Set Check hDlg, %IDC_chkDivisionBy0, 1
    Control Set Check hDlg, %IDC_chkOverflow, 1
    Control Set Check hDlg, %IDC_chkUnderflow, 1
    Control Set Check hDlg, %IDC_chkPrecisionLoss, 1

    Dialog Show Modal hDlg, Call ShowForm1Proc To lRslt

    DeleteObject hFont1

    Function = lRslt
End Function
'--------------------------------------------------------------------------------
