' ----------------------------------------------------------------------
' uCalcPB.Bas : PowerBASIC include file for uCalc Fast Math Parser 2.96
' Designed to work with PB/CC and PB/Win.
'
' Copyright (c) 1999-2008 by Daniel Corbier.
' Visit www.ucalc.com for additional resources.
' ----------------------------------------------------------------------
' Definition properties
%ucAlphaNumeric   = 1
%ucArgSeparator   = 2
%ucCodeBlock      = 3
%ucCodeBlockMatch = 4
%ucEvalInsert     = 5
%ucExpandInsert   = 6
%ucMemberAccess   = 7
%ucQuotedText     = 8
%ucStatementSep   = 9
%ucWhiteSpace     = 10

%ucFuncDefEnd = 11
%ucCurrentThread = 12

%ucPartialBlockStart = 13
%ucPartialBlockEnd   = 14

%ucEvalDuringParse = 15

%ucFunction       = 16
%ucLiteral        = 32
%ucReducible      = 64
%ucSymbol         = 128
%ucVariable       = 256
%ucInfix          = 512
%ucPrefix         = 1024
%ucPostfix        = 2048
%ucOperator       = 4096
%ucPassOnce       = 8192
%ucLock           = 16384


' uCalc Commands
%uc_Define             = 1
%uc_DefineSyntax       = 2
%uc_EvalDbl            = 4
%uc_EvalExt            = 5
%uc_EvalStr            = 6
%uc_EvaluateDbl        = 7
%uc_EvaluateExt        = 8
%uc_Evaluate           = 8
%uc_EvaluateLng        = 9
%uc_EvaluateStr        = 10
%uc_GetCaseSensitivity = 11
%uc_GetCodeAddr        = 12
%uc_GetDefaultPrecedence = 13
%uc_GetDefaultRank     = 14
%uc_GetDefaultType     = 15
%uc_GetDefaultThread   = 16
%uc_GetDefSeparator    = 17
%uc_GetErrorNumber     = 18
%uc_GetParentThread    = 19
%uc_GetSyntaxEqual     = 20
%uc_Parse              = 21
%uc_ReleaseItem        = 22
%uc_SetCaseSensitivity = 23
%uc_SetCodeAddr        = 24
%uc_SetDefaultPrecedence = 25
%uc_SetDefaultRank     = 26
%uc_SetDefaultThread   = 27
%uc_SetDefaultType     = 28
%uc_SetDefSeparator    = 29
%uc_SetErrorNumber     = 30
%uc_SetParentThread    = 31
%uc_SetSyntaxEqual     = 32
%uc_NewThread          = 33
%uc_PartialBlockCount  = 34

%uc_RegExWordBoundaryChars = 35
%uc_RegExEscapeChar = 36
%uc_License = 37
%uc_License_Demo = 0
%uc_License_Free = 2
%uc_License_FMP_Lite = 3
%uc_License_FMP_Standard = 4
%uc_License_LanguageBuilder = 5
%uc_License_Beta = 6

%uc_ReDefine = 38
%uc_AddErrorHandler = 40
%uc_GetSymbolTable = 41

%uc_GetCallbackData = 50
%uc_SetCallbackReturn = 51

%uc_GetExpression = 60
%uc_GetExpressionType = 61
%uc_GetSymbol = 62
%uc_GetItem = 63
%uc_GetLocation = 64

%uc_GetPatternType = 65
%uc_GetPatternProperties = 66

%uc_GetTrigMode = 67
%uc_SetTrigMode = 68

%uc_ItemClone = 70
%uc_DataConvert = 71
%uc_DataCopy = 72
%uc_DataAlloc = 72
%uc_DataFree = 73
%uc_DataReset = 74

%uc_SetFPU = 75
%uc_SetFPU_HostProg = 76
%uc_GetFPU = 77
%uc_GetFPU_HostProg = 78
%uc_ToggleFPU = 79
%uc_ToggleFPU_HostProg = 80
%uc_ErrorClear = 85

%uc_SetErrorMessage = 91
%uc_GetErrorMessage = 92

%uc_SerialNumber = 93
%uc_SetTurbo = 94
%uc_Expand = 95
%uc_GetNextItem = 96
%uc_GetItemData = 97
%uc_SetItemData = 98
%uc_GetThreadAddr = 99
%uc_GetCodeBlock = 100

%uc_Properties = 1
%uc_Thread = 2
%uc_Address = 3
%uc_SymbolName = 4
%uc_Rank = 5
%uc_Precedence = 6
%uc_OverloadHandle = 7
%uc_OverloadCount = 8
%uc_ByteSize = 9
%uc_ArgCount = 10
%uc_DataType = 12
%uc_Handle = 13
%uc_Value = 14
%uc_Property = 15


' Error numbers
%uc_Err_None                    = 0
%uc_Err_Dynamically_Defined     = 1
%uc_Err_Syntax_Error            = 2
%uc_Err_Undefined_Identifier    = 3
%uc_Err_Unknown_Error           = 4
%uc_Err_Unrecognized_Pattern    = 5
%uc_Err_Unrecognized_Command    = 6
%uc_Err_Datatype_Mismatch       = 7
%uc_Err_Invalid_Argument_Count  = 8
%uc_Err_Invalid_Definition      = 9
%uc_Err_CodeBlock_Error         = 10
%uc_Err_Undefined_Callback      = 11
%uc_Err_ErrMsgAlreadyDefined    = 12
%uc_Err_ItemCannotBeModified    = 13
%uc_Err_Unrecognized_Member     = 14

%uc_Err_Array_Bounds_Exceeded   = 20
%uc_Err_Float_Denormal_Operand  = 21
%uc_Err_Float_Divide_By_Zero    = 22
%uc_Err_Float_Inexact_Result    = 23
%uc_Err_Float_Invalid_Operation = 24
%uc_Err_Float_Overflow          = 25
%uc_Err_Float_Stack_Check       = 26
%uc_Err_Float_Underflow         = 27
%uc_Err_Integer_Divide_By_Zero  = 28
%uc_Err_Integer_Overflow        = 29
%uc_Err_Privileged_Instruction  = 30

' FPU Control Word Settings
%uc_FPU_Mask_InvalidOp     = 1
%uc_FPU_Mask_DenormalOp    = 2
%uc_FPU_Mask_ZeroDivide    = 4
%uc_FPU_Mask_Overflow      = 8
%uc_FPU_Mask_Underflow     = 16
%uc_FPU_Mask_PrecisionLoss = 32

%uc_FPU_Precision_Single   = 0
%uc_FPU_Precision_Double   = 256
%uc_FPU_Precision_Extended = 768

%uc_FPU_Round_Even         = 0
%uc_FPU_Round_Down         = 1024
%uc_FPU_Round_Up           = 2048
%uc_FPU_Round_Toward       = 3072


%ucAbort = 0
%ucResume = 1
%ucReRaise = 2

' Data type handler callback action modes
%uc_TypeHandler_Store = 2
%uc_TypeHandler_StringOutput = 3
%uc_TypeHandler_Free = 4
%uc_TypeHandler_FuncRet = 5
%uc_TypeHandler_Copy = 6
%uc_TypeHandler_Alloc = 7
%uc_TypeHandler_Reset = 8

%uc_Callback_Undefined = 0
' Returns error

' Data Type callbacks
%uc_Complex     = 1
%uc_Currency    = 2
%uc_Double      = 3
%uc_Extended    = 4
%uc_Int8        = 5
%uc_Int8u       = 6
%uc_Int16       = 7
%uc_Int16u      = 8
%uc_Int32       = 9
%uc_Int32u      = 10
%uc_Int64       = 11
%uc_Int64u      = 12
%uc_Single      = 13
%uc_String      = 14
%uc_String_LPCSTR= 15
%uc_String_Fixed= 16
%uc_String_Wide = 17
%uc_Stack       = 18
%uc_Void        = 19
%uc_User_Type   = 20

%uc_Convert_Generic = 23
%uc_Convert_Double_Extended = 24
%uc_Convert_Int8_Extended = 25
%uc_Convert_Int8u_Extended = 26
%uc_Convert_Int16_Extended = 27
%uc_Convert_Int16u_Extended = 28
%uc_Convert_Int32_Extended = 29
%uc_Convert_Int32u_Extended = 30
%uc_Convert_Int64_Extended = 31
%uc_Convert_Int64u_Extended = 32
%uc_Convert_Single_Extended = 33
%uc_Convert_Extended_Double = 37
%uc_Convert_Extended_Single = 38
%uc_Convert_Extended_Int16u = 39
%uc_Convert_Extended_Int32 = 40
%uc_Convert_Complex_Extended = 41
%uc_Convert_Extended_Complex = 42

' Default built-in routines.

%uc_Op_Negate_Extended = 43
%uc_Op_UnaryPlus_Extended = 44
%uc_Op_Percentage_Extended = 45
%uc_Op_StrConcat = 46
%uc_Op_Add_Int32 = 47
%uc_Op_Add_Extended = 48
%uc_Op_Add_Complex = 49
%uc_Op_Subtract_Int32 = 50
%uc_Op_Subtract_Extended = 51
%uc_Op_Multiply_Int32 = 52
%uc_Op_Multiply_Extended = 53
%uc_Op_Multiply_Complex = 54
%uc_Op_Divide_Int32 = 55
%uc_Op_Divide_Extended = 56
%uc_Op_Mod_Int32 = 57
%uc_Op_Mod_Extended = 58
%uc_Op_PowerOf_ExtToExt = 59
%uc_Op_PowerOf_ExtToLng = 60
%uc_Op_PowerOf_CplxToCplx = 61

%uc_Op_GreaterThan_Extended = 62
%uc_Op_GreaterOrEqual_Extended = 63
%uc_Op_LessThan_Extended = 64
%uc_Op_LessOrEqual_Extended = 65
%uc_Op_Equal_Extended = 66
%uc_Op_NotEqual_Extended = 67

%uc_Op_GreaterThan_Str = 68
%uc_Op_GreaterOrEqual_Str = 69
%uc_Op_LessThan_Str = 70
%uc_Op_LessOrEqual_Str = 71
%uc_Op_Equal_Str = 72
%uc_Op_NotEqual_Str = 73

%uc_Op_Not_Int32 = 74
%uc_Op_And_Int32 = 75
%uc_Op_Or_Int32 = 76
%uc_Op_Xor_Int32 = 77
%uc_Op_Eqv_Int32 = 78
%uc_Op_Imp_Int32 = 79

%uc_Op_AndAlso = 80
%uc_Op_OrElse = 81

%uc_Op_Factorial = 82

%uc_Func_IIf = 83
%uc_Func_IIf_Str = 84

%uc_Func_Sin = 85
%uc_Func_Cos = 86
%uc_Func_Tan = 87
%uc_Func_Atan = 88
%uc_Func_Ceil = 89
%uc_Func_Abs_Extended = 90
%uc_Func_Abs_Int32 = 91
%uc_Func_Exp = 92
%uc_Func_Log = 93
%uc_Func_Floor = 94
%uc_Func_SquareRoot = 95
%uc_Func_BaseConvert = 96

%uc_Func_ExprHandle = 97
%uc_Func_VarPtr = 98
%uc_Func_uCalc = 99
%uc_Func_uCalcStr = 100
%uc_Func_ucAddr = 101
%uc_Func_ValueAtAddr = 102

%uc_Func_Asc = 103
%uc_Func_Chr = 104

%uc_Func_For  = 105
%uc_Func_Loop = 107

%uc_Func_LoadLibrary = 108
%uc_Func_GetProcAddress = 109

%uc_NullString = 110
%uc_True = 111

%uc_Func_Peek = 112
%uc_Func_Poke = 113

%uc_Func_Int = 115
%uc_Func_Frac = 116
%uc_Func_Sgn = 117

%uc_Func_PushData_Stack = 120
' %uc_Func_PopHandle_Stack = 121
%uc_Func_PopNum_Stack = 122
%uc_Func_PopStr_Stack = 123
%uc_Func_ReadHandle_Stack = 124
%uc_Func_ReadNum_Stack = 125
%uc_Func_ReadStr_Stack = 126
%uc_Func_Count_Stack = 127
%uc_Op_Concat_Stack = 128
%uc_Func_Populate_Stack = 129

%uc_Insert_Table = 130
%uc_Delete_Table = 131
%uc_Index_Table  = 132
%uc_Handle_Table = 133
%uc_HandleB_Table = 134

%uc_Func_StackFormat = 135

%uc_SetVariableValue = 140
%uc_SetVariableValueAnyType = 140
%uc_SetVariableValueLong = 141
%uc_SetVariableValueDouble = 142
%uc_SetVariableValueExtended = 143

' Misc other callbacks
%uc_EvaluateAddr = 150
%uc_EvaluateTurboAddr = 151
%uc_ExceptionHelper = 152
%uc_DefaultErrorHandler = 153
%uc_Raise_Error = 154

' Interpreter addresses
%uc_Interp_DefHandle     = 160 ' DWord Ptr
%uc_Interp_ExitCommand   = 161 ' String Ptr
%uc_Interp_LastResultNum = 163 ' Extended Ptr
%uc_Interp_LastResultStr = 164 ' String Ptr
%uc_Interp_LineContinue  = 165
%uc_Interp_MainPrompt    = 166
%uc_Interp_MultiLinePrompt = 167
%uc_Interp_Prefix = 168
%uc_Interp_Postfix = 169
%uc_Interp_Tab = 170
%uc_Interp_Insert = 171
%uc_Interp_InputBuffer = 172
%uc_Interp_OutputBuffer = 173
%uc_Interp_KeyCode = 174
%uc_Interp_KeyExtCode = 175

%uc_Op_Ext_Plus_Complex = 190
%uc_Op_Ext_Times_Complex = 191

%uc_Func_If_ElseIf = 195
%uc_Func_SetSyntaxParams = 196
%uc_Func_SpecialUCase = 197
%uc_Func_Rand = 198
%uc_Func_Batch_Eval = 199

%uc_Op_Add_Double = 201
%uc_Op_Subtract_Double = 202
%uc_Op_Multiply_Double = 203
%uc_Op_Divide_Double = 204
%uc_Op_Mod_Double = 205
%uc_Op_PowerOf_DblToDbl = 206
%uc_Op_PowerOf_DblToLng = 207

%uc_Func_Sin_Dbl = 208
%uc_Func_Cos_Dbl = 209
%uc_Func_Tan_Dbl = 210
%uc_Func_Atan_Dbl = 211
%uc_Func_Ceil_Dbl = 212
%uc_Func_Abs_Dbl = 213
%uc_Func_Exp_Dbl = 214
%uc_Func_Log_Dbl = 215
%uc_Func_SquareRoot_Dbl = 216

%uc_Convert_Double_Int32 = 218
%uc_Convert_Int32_Double = 219

%ucTrue  = 1
%ucFalse = 0

%uc_First = 1
%uc_Last  = -1

' Trig Modes
%uc_ReturnTrigMode = 0
%uc_Radians = 1
%uc_Degrees = 2
%uc_Grad    = 3

' End Of Constants

Global ucIsInitialized As Long
Global ucExtended, ucString, ucLPCSTR, ucFixedString, ucDouble, ucSingle As Dword
Global ucLong, ucDword, ucComplex, ucByte, ucTable, ucVoid, ucStack As Dword
Global ucSortedList As Dword
Global uCalc_Addr As Dword
Global ucEvaluate_Addr As Dword
Global ucExprThread_Addr As Dword
Global ucParamDbl_Addr As Dword
Global ucParamCount_Addr As Dword
Global ucParamStr_Addr As Dword
Global ucReturnDbl_Addr As Dword
Global ucReturnStr_Addr As Dword
Global ucSetVariableValueDbl_Addr As Dword
Global ucSetVariableValueExt_Addr As Dword
Global ucSetVariableValueStr_Addr As Dword
Global ucStrReturn_Addr As Dword

Union ucValueType
   ValuePtr  As Dword    Ptr
   ValueExt  As Extended Ptr
End Union

Type ucExpressionType
   LeftExt   As Extended Ptr
   RightExt  As Extended Ptr
   ResultExt As Extended Ptr
   ArgList   As ucValueType Ptr
End Type

#If Not %Def(%ucMake)
   #If %Def(%ucDebug)
      Macro ucEvaluate(ExprHandle) = ucEvaluateExt(ExprHandle)
      Sub ucReturnStr(ByVal Expr As Dword, ReturnValue As String)
         ucReturnStr_(Expr, StrPtr(ReturnValue))
      End Sub
   #Else
      Declare Function GetProcAddress Lib "KERNEL32.DLL" Alias "GetProcAddress" (ByVal hModule As Dword, lpProcName As Asciiz) As Long
      Declare Function LoadLibrary Lib "KERNEL32.DLL" Alias "LoadLibraryA" (lpLibFileName As Asciiz) As Long

      Declare Function ucEvaluate_(ByVal ucItem As Dword) As Extended
      Declare Function ucExprThread_(ByVal Expr As Dword) As Dword
      Declare Function ucParamDbl_(ByVal Expr As Dword, ByVal pIndex As Long) As Double
      Declare Function ucParamCount_(ByVal Expr As Dword) As Long
      Declare Function ucParamStr_(ByVal Expr As Dword, ByVal pIndex As Long) As String
      Declare Function ucStrReturn_(ByVal TextPtr As Dword) As String
      Declare Sub      ucReturnDbl_(ByVal Expr As Dword, ByVal ReturnValue As Double)
      Declare Sub      ucReturnStr_(ByVal Expr As Dword, ByVal ReturnValue As Asciiz Ptr)
      Declare Sub      ucSetVariableValueDbl_(ByVal ucItem As Dword, ByVal NewValue As Double)
      Declare Sub      ucSetVariableValueExt_(ByVal ucItem As Dword, ByVal NewValue As Extended)
      Declare Sub      ucSetVariableValueStr_(ByVal ucItem As Dword, ByVal NewValue As Asciiz Ptr)

      Declare Function uCalc__(ByVal ucCommand As Long, ByVal TextArg As Dword, _
      ByVal MiscArg1 As Dword, ByVal MiscArg2 As Dword, ByVal ReturnPtr As Dword, ByVal t As Dword) As Dword

      Macro ucExpression = ucExpressionType Ptr
      Macro ucParam(Expr, Index) = @Expr.@ArgList[Index].@ValueExt
      Macro ucParamHandle(Expr, Index) = @Expr.@ArgList[index].ValuePtr
      Macro ucReturn(Expr, ReturnValue) = @Expr.@ResultExt = ReturnValue

      Macro Function uCalc_(ucCommand, TextArg, MiscArg1, MiscArg2, ReturnPtr, t)
         MacroTemp ReturnValue
         Dim ReturnValue As Dword

         Call Dword uCalc_Addr Using uCalc__(ucCommand, TextArg, MiscArg1, MiscArg2, ReturnPtr, t) To ReturnValue
      End Macro = ReturnValue

      Macro Function ucEvaluate(Expr)
         MacroTemp ReturnValue
         Dim ReturnValue As Extended

         Call Dword ucEvaluate_Addr Using ucEvaluate_(Expr) To ReturnValue
      End Macro = ReturnValue

      Macro Function ucExprThread(Expr)
         MacroTemp ReturnValue
         Dim ReturnValue As Dword

         Call Dword ucExprThread_Addr Using ucExprThread_(Expr) To ReturnValue
      End Macro = ReturnValue

      Macro Function ucParamDbl(Expr, pIndex)
         MacroTemp ReturnValue
         Dim ReturnValue As Double

         Call Dword ucParamDbl_Addr Using ucParamDbl_(Expr, pIndex) To ReturnValue
      End Macro = ReturnValue

      Macro Function ucParamCount(Expr)
         MacroTemp ReturnValue
         Dim ReturnValue As Long

         Call Dword ucParamCount_Addr Using ucParamCount_(Expr) To ReturnValue
      End Macro = ReturnValue

      Macro Function ucParamStr(Expr, pIndex)
         MacroTemp ReturnValue
         Dim ReturnValue As String

         Call Dword ucParamStr_Addr Using ucParamStr_(Expr, pIndex) To ReturnValue
      End Macro = ReturnValue

      Macro Function ucStrReturn(TextPtr)
         MacroTemp ReturnValue
         Dim ReturnValue As String

         Call Dword ucStrReturn_Addr Using ucStrReturn_(TextPtr) To ReturnValue
      End Macro = ReturnValue

      Macro ucReturnDbl(Expr, ReturnValue)
         Call Dword ucReturnDbl_Addr Using ucReturnDbl_(Expr, ReturnValue)
      End Macro

      Macro ucReturnStr(Expr, ReturnValue)
         MacroTemp ReturnValueStr
         Dim ReturnValueStr As String

         ReturnValueStr = ReturnValue
         Call Dword ucReturnStr_Addr Using ucReturnStr_(Expr, StrPtr(ReturnValueStr))
      End Macro

      Macro ucSetVariableValue(ucItem, NewValue)
         Call Dword ucSetVariableValueExt_Addr Using ucSetVariableValueExt_(ucItem, NewValue)
      End Macro
      Macro ucSetVariableValueDbl(ucItem, NewValue)
         Call Dword ucSetVariableValueDbl_Addr Using ucSetVariableValueDbl_(ucItem, NewValue)
      End Macro
      Macro ucSetVariableValueStr(ucItem, NewValue)
         Call Dword ucSetVariableValueStr_Addr Using ucSetVariableValueStr_(ucItem, NewValue)
      End Macro
   #EndIf

Function uCalc(ByVal ucCommand As Long, Optional ByVal TextArg As Dword, _
               ByVal MiscArg1 As Dword, ByVal MiscArg2 As Dword, _
               ByVal ReturnPtr As Dword, ByVal t As Dword) As Dword

   If ucIsInitialized = %ucFalse Then Call ucInitialize()
   Function = uCalc_(ucCommand, TextArg, MiscArg1, MiscArg2, ReturnPtr, t)
End Function

Function uCalcStr(ByVal ucCommand As Long, Optional ByVal TextArg As Dword, _
               ByVal MiscArg1 As Dword, ByVal MiscArg2 As Dword, _
               ByVal ReturnPtr As Dword, ByVal t As Dword) As String

   If ucIsInitialized = %ucFalse Then Call ucInitialize()
   Function = ucStrReturn(uCalc_(ucCommand, TextArg, MiscArg1, MiscArg2, ReturnPtr, t))
End Function

Function ucAddr(ByVal AddressIndex As Long) As Dword
   Function = uCalc(%uc_GetCodeAddr, 0, AddressIndex)
End Function

Function ucDefine(Definition As String, Optional ByVal Arg1 As Dword, ByVal Arg2 As Dword, _
                  ByVal Arg3 As Dword, ByVal t As Dword) As Dword
   Function = uCalc(%uc_Define, StrPtr(Definition), Arg1, Arg2, Arg3, t)
End Function

Function ucDefineConstant(Definition As String, Optional ByVal t As Dword) As Dword
   Dim ItemDef$
   ItemDef$ = "Var: " + Definition
   Function = uCalc(%uc_Define, StrPtr(ItemDef$), %ucLock, 0, 0, t)
End Function

Function ucDefineFunction(Definition As String, Optional ByVal ItemAddress As Dword, ByVal t As Dword) As Dword
   Dim ItemDef$
   ItemDef$ = "Func: " + Definition
   If ItemAddress Then ItemDef$ = ItemDef$ + " At " + Str$(ItemAddress)
   Function = uCalc(%uc_Define, StrPtr(ItemDef$), 0, 0, 0, t)
End Function

Function ucDefineOperator(Definition As String, Optional ByVal ItemAddress As Dword, ByVal t As Dword) As Dword
   Dim ItemDef$
   ItemDef$ = "Op: " + Definition
   If ItemAddress Then ItemDef$ = ItemDef$ + " At " + Str$(ItemAddress)
   Function = uCalc(%uc_Define, StrPtr(ItemDef$), 0, 0, 0, t)
End Function

Function ucDefineSyntax(Definition As String, Optional ByVal Rank As Dword, ByVal t As Dword) As Dword
   If Rank = 0 Then Rank = 1
   Function = uCalc(%uc_DefineSyntax, StrPtr(Definition), Rank, 0, 0, t)
End Function

Function ucDefineVariable(Definition As String, Optional ByVal ItemAddress As Dword, ByVal t As Dword) As Dword
   Dim ItemDef$
   ItemDef$ = "Var: " + Definition
   If ItemAddress Then ItemDef$ = ItemDef$ + " At " + Str$(ItemAddress)
   Function = uCalc(%uc_Define, StrPtr(ItemDef$), 0, 0, 0, t)
End Function

Function ucEval(Expr As String, Optional ByVal t As Dword) As Extended
   Dim Answer As Extended

   uCalc(%uc_EvalExt, StrPtr(Expr), 0, 0, VarPtr(Answer), t)
   Function = Answer
End Function

Function ucEvalStr(Expr As String, Optional ByVal ExprType As Dword, ByVal t As Dword) As String
   Function = uCalcStr(%uc_EvalStr, StrPtr(Expr), ExprType, 0, 0, t)
End Function

Function ucEvaluateStr(ByVal ucItem As Dword) As String
   Function = uCalcStr(%uc_EvaluateStr, 0, ucItem)
End Function

Function ucExpand(Expr As String, Optional ByVal t As Dword) As String
   Function = uCalcStr(%uc_Expand, StrPtr(Expr), 0, 0, 0, t)
End Function

Function ucErrorMessage(Optional ByVal ErrNum As Dword, ByVal t As Dword) As String
   Function = uCalcStr(%uc_GetErrorMessage, 0, ErrNum, 0, 0, t)
End Function
Function ucGetError(Optional ByVal t As Dword) As Long
   Function = uCalc(%uc_GetErrorNumber, 0, 0, 0, 0, t)
End Function
Function ucError(Optional ByVal t As Dword) As Long
   Function = uCalc(%uc_GetErrorNumber, 0, 0, 0, 0, t)
End Function
Function ucRaiseError(ByVal Expr As Dword, ByVal ErrorNum As Long) As Long
   Function = uCalc(%uc_SetErrorNumber, 0, ErrorNum, Expr, 0, ucExprThread(Expr))
End Function
Sub ucRaiseErrorMessage(ByVal Expr As Dword, ErrMessage As String)
   uCalc(%uc_SetErrorMessage, StrPtr(ErrMessage), %uc_Err_Dynamically_Defined, 0, 0, ucExprThread(Expr))
   uCalc(%uc_SetErrorNumber, 0, %uc_Err_Dynamically_Defined, Expr, 0, ucExprThread(Expr))
End Sub
Function ucSetError(ByVal ErrorNum As Long, Optional ByVal t As Dword) As Long
   Function = uCalc(%uc_SetErrorNumber, 0, ErrorNum, 0, 0, t)
End Function
Function ucErrLocation(ByVal t As Dword) As Long
   Function = uCalc(%uc_GetLocation, 0, 0, 0, 0, t)
End Function
Function ucErrSymbol(ByVal t As Dword) As String
   Function = uCalcStr(%uc_GetSymbol, 0, 0, 0, 0, t)
End Function

Function ucGetCodeBlock(Expr As String, ByRef i As Long, Optional ByVal ucOption As Long, Optional ByVal t As Dword) As String
   Function = uCalcStr(%uc_GetCodeBlock, StrPtr(Expr), 0, ucOption, VarPtr(i), t)
End Function

Function ucGetExpr(Optional t As Dword) As String
   Function = uCalcStr(%uc_GetExpression, 0, 0, 0, 0, t)
End Function

Function ucGetItemHandle(SymbolName As String, Optional ByVal ucProperties As Dword, ByVal t As Dword) As Dword
   Function = uCalc(%uc_GetItemData, StrPtr(SymbolName), 0, %uc_Handle, ucProperties, t)
End Function

Function ucGetNextItem(Expr As String, ByRef i As Long, Optional ByVal ucOption As Long, Optional ByVal t As Dword) As String
   Function = uCalcStr(%uc_GetNextItem, StrPtr(Expr), 0, ucOption, VarPtr(i), t)
End Function

Function ucGetSymbol(ByVal t As Dword) As String
   Function = uCalcStr(%uc_GetSymbol, 0, 0, 0, 0, t)
End Function

Function ucGetTrigMode() As Long
   Function = uCalc(%uc_GetTrigMode)
End Function

Function ucInterpret(Expr As String, Optional ByVal ExprType As Dword, ByVal t As Dword) As String
   Function = uCalcStr(%uc_EvalStr, StrPtr(Expr), ExprType, 1, 0, t)
End Function

Function ucNewThread(Optional ByVal ParentThread As Dword) As Dword
   Function = uCalc(%uc_NewThread, 0, ParentThread)
End Function

Function ucParse(Expr As String, Optional ByVal ExprType As Dword, ByVal t As Dword) As Dword
   Function = uCalc(%uc_Parse, StrPtr(Expr), ExprType, 0, 0, t)
End Function

Function ucReleaseItem(ByVal ucItem As Dword) As Long
   Function = uCalc(%uc_ReleaseItem, 0, ucItem)
End Function

Function ucSetErrMsg(ByVal ErrIndex As Long, ErrMessage As String, Optional ByVal t As Dword) As Long
   Function = uCalc(%uc_SetErrorMessage, StrPtr(ErrMessage), ErrIndex, 0, 0, t)
End Function

Function ucSetErrorNumber(ByVal ErrorNumber As Long, Optional ByVal t As Dword) As Long
   Function = uCalc(%uc_SetErrorNumber, 0, ErrorNumber, 0, 0, t)
End Function

Sub ucSetTrigMode(ByVal TrigMode As Long)
   uCalc(%uc_SetTrigMode, 0, TrigMode)
End Sub

Function ucLicense(ByVal LicenseOption As Long, Optional ByVal L1 As Dword, ByVal L2 As Dword, ByVal L3 As Dword) As Long
   Static hDLL As Dword

   If hDLL = 0 Then
      hDLL               = LoadLibrary("ucFMP296.DLL")
      uCalc_Addr         = GetProcAddress(hDLL, "uCalc")
      ucEvaluate_Addr    = GetProcAddress(hDLL, "ucEvaluateExt")
      ucExprThread_Addr  = GetProcAddress(hDLL, "ucExprThread")
      ucParamDbl_Addr    = GetProcAddress(hDLL, "ucParamDbl")
      ucParamCount_Addr  = GetProcAddress(hDLL, "ucParamCount")
      ucParamStr_Addr    = GetProcAddress(hDLL, "ucParamStr")
      ucReturnDbl_Addr   = GetProcAddress(hDLL, "ucReturnDbl")
      ucReturnStr_Addr   = GetProcAddress(hDLL, "ucReturnStr")
      ucStrReturn_Addr   = GetProcAddress(hDLL, "ucStrReturn")
      ucSetVariableValueExt_Addr = GetProcAddress(hDLL, "ucSetVariableValueExt")
      ucSetVariableValueDbl_Addr = GetProcAddress(hDLL, "ucSetVariableValueDbl")
      ucSetVariableValueStr_Addr = GetProcAddress(hDLL, "ucSetVariableValueStr")
   End If

   Function = uCalc_(%uc_License, L1, LicenseOption, L2, L3, 0)
End Function

#If Not %Def(%ucInterpreter)
Function ucInitialize() As Dword
   ucInitialize = ucLicense(%uc_License_Demo)
   ucIsInitialized = %ucTrue

   ucSetErrMsg %uc_Err_None,                    "No error"
   ucSetErrMsg %uc_Err_Syntax_Error,            "Syntax error"
   ucSetErrMsg %uc_Err_Undefined_Identifier,    "Undefined identifier"
   ucSetErrMsg %uc_Err_Unknown_Error,           "Unknown error"
   ucSetErrMsg %uc_Err_Unrecognized_Pattern,    "Unrecognized pattern"
   ucSetErrMsg %uc_Err_Unrecognized_Command,    "Unrecognized command"
   ucSetErrMsg %uc_Err_Datatype_Mismatch,       "Data type mismatch"
   ucSetErrMsg %uc_Err_CodeBlock_Error,         "Code block delimiter error"
   ucSetErrMsg %uc_Err_Invalid_Argument_Count,  "Invalid number of arguments"
   ucSetErrMsg %uc_Err_Invalid_Definition,      "Invalid definition"
   ucSetErrMsg %uc_Err_Undefined_Callback,      "Undefined callback"
   ucSetErrMsg %uc_Err_ErrMsgAlreadyDefined,    "Error message already defined"
   ucSetErrMsg %uc_Err_ItemCannotBeModified,    "This item cannot be modified"
   ucSetErrMsg %uc_Err_Unrecognized_Member,     "Unrecognized member"
   ucSetErrMsg %uc_Err_Array_Bounds_Exceeded,   "Array bounds exceeded"
   ucSetErrMsg %uc_Err_Float_Denormal_Operand,  "Denormal operand"
   ucSetErrMsg %uc_Err_Float_Divide_By_Zero,    "Division by 0"
   ucSetErrMsg %uc_Err_Float_Inexact_Result,    "Inexact result"
   ucSetErrMsg %uc_Err_Float_Invalid_Operation, "Invalid operation"
   ucSetErrMsg %uc_Err_Float_Overflow,          "Floating point overflow"
   ucSetErrMsg %uc_Err_Float_Stack_Check,       "Floating point stack Error"
   ucSetErrMsg %uc_Err_Float_Underflow,         "Floating point underflow"
   ucSetErrMsg %uc_Err_Integer_Divide_By_Zero,  "Integer division by 0"
   ucSetErrMsg %uc_Err_Integer_Overflow,        "Integer overflow"
   ucSetErrMsg %uc_Err_Privileged_Instruction,  "Privileged instruction denied"

   ' Extended, Double, and Single must be defined in that order, and prior to other types.
   ucExtended = ucDefine("DataType: Extended ~~ Size: 10 ~~ TypeHandler: #", ucAddr(%uc_Extended))
   ucDouble   = ucDefine("DataType: Double   ~~ Size: 8  ~~ TypeHandler: # ~~ ConvertsTo: Extended, #", ucAddr(%uc_Double), ucAddr(%uc_Convert_Double_Extended))
   ucSingle   = ucDefine("DataType: Single   ~~ Size: 4  ~~ TypeHandler: # ~~ ConvertsTo: Extended, #", ucAddr(%uc_Single), ucAddr(%uc_Convert_Single_Extended))
   ucLong     = ucDefine("DataType: Long     ~~ Size: 4  ~~ TypeHandler: # ~~ ConvertsTo: Extended, #", ucAddr(%uc_Int32),  ucAddr(%uc_Convert_Int32_Extended))
   ucDword    = ucDefine("DataType: Dword    ~~ Size: 4  ~~ TypeHandler: # ~~ ConvertsTo: Extended, #", ucAddr(%uc_Int32u), ucAddr(%uc_Convert_Int32u_Extended))
   ucString   = ucDefine("DataType: String   ~~ Size: 4  ~~ TypeHandler: # ~~ ConvertsTo: LPCSTR", ucAddr(%uc_String))
   ucFixedString = ucDefine("DataType: FixedString ~~ TypeHandler: # ~~ ConvertsTo: String ~~ ConvertsFrom: String", ucAddr(%uc_String_Fixed))
   ucByte     = ucDefine("DataType: Byte     ~~ Size: 1  ~~ TypeHandler: # ~~ ConvertsTo: Extended, #", ucAddr(%uc_Int8u), ucAddr(%uc_Convert_Int8u_Extended))
   ucLPCSTR   = ucDefine("DataType: LPCSTR               ~~ TypeHandler: # ~~ ConvertsTo: String", ucAddr(%uc_String_LPCSTR))
   ucStack    = ucDefine("DataType: Stack    ~~ Size: 4  ~~ TypeHandler: #", ucAddr(%uc_Stack))
   ucSortedList = ucDefine("DataType: SortedList ~~ Size: 4  ~~ TypeHandler: #", ucAddr(%uc_Stack))
   ucTable    = ucDefine("DataType: Table    ~~ Size: 4      ~~ TypeHandler: #", ucAddr(%uc_Stack))
   ucVoid     = ucDefine("DataType: Void     ~~ Size: 10 ~~ TextData: Ok ~~ TypeHandler: #", ucAddr(%uc_Void))

   ucExtended = ucDefine("DataType: Extended ~~ ConvertsTo: Long, #", ucAddr(%uc_Convert_Extended_Int32))
   ucExtended = ucDefine("DataType: Extended ~~ ConvertsTo: Dword, #", ucAddr(%uc_Convert_Extended_Int32))
   ucExtended = ucDefine("DataType: Extended ~~ ConvertsTo: Double, #", ucAddr(%uc_Convert_Extended_Double))
   ucExtended = ucDefine("DataType: Extended ~~ ConvertsTo: Single, #", ucAddr(%uc_Convert_Extended_Single))
   ucExtended = ucDefine("DataType: Extended ~~ ConvertsTo: Byte")

   ucDword = ucDefine("DataType: Dword ~~ ConvertsTo: Long")
   ucDefine("DataType: Double ~~ ConvertsTo: Long, #", ucAddr(%uc_Convert_Double_Int32))
   ucDefine("DataType: Long ~~ ConvertsTo: Double, #", ucAddr(%uc_Convert_Int32_Double))

   ucDefine("Pattern:[\x00\x01\x02]") ' Reserved characters
   ucDefine("Pattern:\x03 ~~ \x03 ~~ DataType: #2", %ucQuotedText+%ucLiteral, ucString)
   ucDefine("Pattern:\x05") ' Define Codeblock bootstrap
   ucDefine("Pattern:\x06 ~~ \x07", %ucCodeBlock)
   ucDefine("Pattern: :")
   ucDefine("Pattern: :=")
   ucDefine("Pattern:\[ ~~ \]", %ucCodeBlock)
   ucDefine("Pattern:\{ ~~ \} ~~ DataType: #2 ~~ Address: #3", %ucCodeBlock, ucStack, ucAddr(%uc_Func_Populate_Stack))
   ucDefine("Pattern:[\q] ~~ [\q] ~~ DataType: #2", %ucQuotedText+%ucLiteral, ucString)
   ucDefine("Pattern:['] ~~ ['] ~~ DataType: #2", %ucQuotedText+%ucLiteral, ucString)
   ucDefine("Pattern:\x0D\x0A", %ucStatementSep) ' Carriage Return
   ucDefine("Pattern:;", %ucStatementSep)
   ucDefine("Pattern:~t", %ucCurrentThread)
   ucDefine("Pattern:~Eval", %ucEvalInsert)
   ucDefine("Pattern:~Eval_1 ~~ PassOnce", %ucEvalInsert)
   ucDefine("Pattern:~Eval_P", %ucEvalDuringParse)
   ucDefine("Pattern:~Expand", %ucExpandInsert)
   ucDefine("Pattern:~Expand_1 ~~ PassOnce", %ucExpandInsert)
   ucDefine("Pattern:\.", %ucMemberAccess)
   ucDefine("Pattern:\~\~")
   ucDefine("Pattern:,", %ucArgSeparator)
   ucDefine("Pattern:\( ~~ \)", %ucCodeBlock)
   ucDefine("Pattern:[ \t]+", %ucWhiteSpace)
   ucDefine("Pattern:[\|+/*^$&#\-=%@!`\\<>?]+", %ucReducible)  ' For operators
   ucDefine("Pattern:([0-9]*\.)?[0-9]+(e[-+]?[0-9]+)? ~~ DataType: #2", %ucLiteral, ucExtended) ' Numeric
   ucDefine("Pattern:[a-z_][0-9a-z_]* ~~ Name: AlphaNum", %ucAlphaNumeric)

   ucDefineSyntax "Op: {Name} '{' {Operand} '}' [As {type}] ::=" _ ' Prefix Operator
                 +"Param: {Operand} ~~ Name: {Name} ~~ DataType: {type} ~~ Properties: " + Str$(%ucPrefix+%ucOperator)
   ucDefineSyntax "Op: '{' {Operand} '}' {Name} [As {type}] ::=" _ ' Postfix Operator
                 +"Param: {Operand} ~~ Name: {Name} ~~ DataType: {type} ~~ Properties: " + Str$(%ucPostfix+%ucOperator)
   ucDefineSyntax "Op: '{' {LeftOp} '}' {Name} '{' {RightOp} '}' [As {type}] ::=" _ ' Infix Operator
                 +"Param: {LeftOp} ~~ Param: {RightOp} ~~ Name: {Name} ~~ DataType: {type} ~~ Properties: " + Str$(%ucInfix+%ucOperator)

   ucDefineSyntax "Op: {Def} { At {addr} | ':=' {Expr:'.+'} } ::= Op: {Def} {addr: ~~ Address: {addr} ~~ StdCall} {Expr: ~~ FuncBody: {Expr}}"
   ucDefineSyntax "Op: {pValue:' *[0-9]+ '} {Def} ::= Precedence: {pValue} ~~ Op: {Def}"
   ucDefineSyntax "Op: Precedence({op}) ::= Op: ~Eval(Precedence({op}))"
   ucDefineSyntax "Op:: {Def:'.+'} ::= NativeCall ~~ Address: # ~~ Op: {Def}"
   ucDefineSyntax "Op: Native: {Def} At {Addr} ::= NativeCall ~~ Address: {Addr} ~~ Op: {Def}"

   ucDefineSyntax "Var: {VarName:'[ ]*[a-z_][0-9a-z_]*'} [As {Type}] [= {Value}] [At {Addr:' .+'}] ::=" _
                  +"Variable ~~ Name: {VarName}" _
                  +"{Type: ~~ DataType: {Type}}" _
                  +"{Value: ~~ Value: {Value}}" _
                  +"{Addr: ~~ Address: {Addr}}"
   ucDefineSyntax "Var: {VarName:'[ ]*[a-z_][0-9a-z_]*'} As AnyType ::= AnyType ~~ Var: {VarName}"
   ucDefineSyntax "Var: {PassBy:'( +ByRef)|( +ByVal)|( +ByHandle)|( +ByExpr)'} ::= {PassBy} ~~ Var:"
   ucDefineSyntax "Var: {Def} ... ::= Var: {Def} ~~ VariableArgList"
   ucDefineSyntax "Var: ... ::= Var: _ ~~ VariableArgList"
   ucDefineSyntax "Var: {name:' *[_a-z]*'} = {quote:' *[\x22\x27]'} ::= Var: {name} As String = {quote}"
   ucDefineSyntax "Const: {Def:'.*'} ::= Var: {Def} ~~ Properties: " + Str$(%ucLock)
   ucDefineSyntax "=- ::= = -"

   ucDefineSyntax "Func: {FuncName} ([{ParamList}]) [As {type:' +[a-z]+[a-z0-9]*'}] [{ At {addr} | = {Def:'.+'} }] ::= " _
                  +"Params: ({ParamList}) ~~ Name: {FuncName} ~~ DataType: {type}" _
                  +"~~ Properties: " + Str$(%ucFunction + %ucPrefix) _
                  +"{addr: ~~ Address: {addr} ~~ StdCall} ~~ FuncBody: {Def}"
   ucDefineSyntax "Func:: {Def:'.+'} ::= NativeCall ~~ Address: # ~~ Func: {Def}"
   ucDefineSyntax "Func: Native: {Def} At {Addr} ::= NativeCall ~~ Address: {Addr} ~~ Func: {Def}"

   ucDefineSyntax "Params: ([{SingleParam}]) ::= IsParam ~~ { {SingleParam: Var: {SingleParam}} }"
   ucDefineSyntax "Params: ({Variable} = {Default}) ::= Params: ({Variable} ~~ TextData: {Default})"
   ucDefineSyntax "Params: ({Param1}, {OtherParams}) ::= Params: ({Param1}) ~~ Params: ({OtherParams})"
   ucDefineSyntax "Param: {ParamDef} ~~ ::= IsParam ~~ { Var: {ParamDef} } ~~"

   ucDefine("Op:: -{x}    ~~ Precedence: 25", ucAddr(%uc_Op_Negate_Extended))
   ucDefine("Op:: {x As String}+{y As String} As String ~~ Precedence: 10", ucAddr(%uc_Op_StrConcat))
   ucDefine("Op:: {x As Long}+{y As Long} As Long ~~ Precedence: 10", ucAddr(%uc_Op_Add_Int32))

   ucExtended = ucDefine("DataType: Extended ~~ ConvertsTo: Complex, #", ucAddr(%uc_Convert_Extended_Complex))
   ucComplex  = ucDefine("DataType: Complex ~~ {Var: Real As Extended} ~~ {Var: Imag As Extended = 1} ~~ TypeHandler: #", ucAddr(%uc_Complex))
   ucDefine("Pattern:#i ~~ DataType: #2", %ucLiteral, ucComplex)
   ucDefine("Op:: {x As Complex}+{y As Complex} As Complex ~~ Precedence: 10", ucAddr(%uc_Op_Add_Complex))
   ucDefine("Op:: {x As Complex}*{y As Complex} As Complex ~~ Precedence: 10", ucAddr(%uc_Op_Multiply_Complex))

   ucDefine("Op:: {x}>{y}  As Long ~~ Precedence: 5", ucAddr(%uc_Op_GreaterThan_Extended))
   ucDefine("Op:: {x}<{y}  As Long ~~ Precedence: 5", ucAddr(%uc_Op_LessThan_Extended))
   ucDefine("Op:: {x}>={y} As Long ~~ Precedence: 5", ucAddr(%uc_Op_GreaterOrEqual_Extended))
   ucDefine("Op:: {x}<={y} As Long ~~ Precedence: 5", ucAddr(%uc_Op_LessOrEqual_Extended))
   ucDefine("Op:: {x}<>{y} As Long ~~ Precedence: 5", ucAddr(%uc_Op_NotEqual_Extended))
   ucDefine("Op:: {x}=={y} As Long ~~ Precedence: 5", ucAddr(%uc_Op_Equal_Extended))

   ucDefine("Op:: {x As String}>{y As String}  As Long ~~ Precedence: 5", ucAddr(%uc_Op_GreaterThan_Str))
   ucDefine("Op:: {x As String}<{y As String}  As Long ~~ Precedence: 5", ucAddr(%uc_Op_LessThan_Str))
   ucDefine("Op:: {x As String}>={y As String} As Long ~~ Precedence: 5", ucAddr(%uc_Op_GreaterOrEqual_Str))
   ucDefine("Op:: {x As String}<={y As String} As Long ~~ Precedence: 5", ucAddr(%uc_Op_LessOrEqual_Str))
   ucDefine("Op:: {x As String}<>{y As String} As Long ~~ Precedence: 5", ucAddr(%uc_Op_NotEqual_Str))
   ucDefine("Op:: {x As String}=={y As String} As Long ~~ Precedence: 5", ucAddr(%uc_Op_Equal_Str))

   ucDefine("Op:: {x As Long} And     {y As Long} As Long ~~ Precedence: 4", ucAddr(%uc_Op_And_Int32))
   ucDefine("Op:: {x}         AndAlso {ByExpr y}          ~~ Precedence: 4", ucAddr(%uc_Op_AndAlso))
   ucDefine("Op:: {x As Long} Or      {y As Long} As Long ~~ Precedence: 3", ucAddr(%uc_Op_Or_Int32))
   ucDefine("Op:: {x}         OrElse  {ByExpr y}          ~~ Precedence: 3", ucAddr(%uc_Op_OrElse))

   ucDefine("Op:: {x}+{y} ~~ Precedence: 10", ucAddr(%uc_Op_Add_Extended))
   ucDefine("Op:: {x}-{y} ~~ Precedence: 10", ucAddr(%uc_Op_Subtract_Extended))
   ucDefine("Op:: {x}*{y} ~~ Precedence: 20", ucAddr(%uc_Op_Multiply_Extended))
   ucDefine("Op:: {x}/{y} ~~ Precedence: 20", ucAddr(%uc_Op_Divide_Extended))
   ucDefine("Op:: {x} Mod {y} ~~ Precedence: 20", ucAddr(%uc_Op_Mod_Extended))
   ucDefine("Op:: {x}^{y} ~~ Precedence: 30", ucAddr(%uc_Op_PowerOf_ExtToExt))

   ucDefine("Op:: {x As Long}!  ~~ Precedence: 40", ucAddr(%uc_Op_Factorial))
   ucDefine("Op:: {x As Long}\{y As Long} As Long ~~ Precedence: 20", ucAddr(%uc_Op_Divide_Int32))

   ucDefine("Func:: Sin(x)", ucAddr(%uc_Func_Sin))
   ucDefine("Func:: Cos(x)", ucAddr(%uc_Func_Cos))
   ucDefine("Func:: Tan(x)", ucAddr(%uc_Func_Tan))
   ucDefine("Func:: Atan(x)", ucAddr(%uc_Func_Atan))
   ucDefine("Func:: Abs(x)", ucAddr(%uc_Func_Abs_Extended))
   ucDefine("Func:: Exp(x)", ucAddr(%uc_Func_Exp))
   ucDefine("Func:: Log(x)", ucAddr(%uc_Func_Log))
   ucDefine("Func:: Ceil(x) As Long", ucAddr(%uc_Func_Ceil))
   ucDefine("Func:: Sqr(x)", ucAddr(%uc_Func_SquareRoot))
   ucDefine("Func:: Int(x)", ucAddr(%uc_Func_Int))
   ucDefine("Func:: Frac(x)", ucAddr(%uc_Func_Frac))
   ucDefine("Func:: Sgn(x)", ucAddr(%uc_Func_Sgn))
   ucDefine("Func:: Rand(x = 1)", ucAddr(%uc_Func_Rand))
   ucDefine("Func:: Rand(x As Long, y As Long)", ucAddr(%uc_Func_Rand))

   ucDefine("Syntax: Max({x}, {y}) ::= IIf({x} > {y}, {x}, {y})")
   ucDefine("Syntax: Max({x}, {y}, {etc}) ::= Max({x}, Max({y}, {etc}))")
   ucDefine("Syntax: Min({x}, {y}) ::= IIf({x} < {y}, {x}, {y})")
   ucDefine("Syntax: Min({x}, {y}, {etc}) ::= Min({x}, Min({y}, {etc}))")

   ucDefine("Func:: BaseConvert(Number As String, Base As Long)", ucAddr(%uc_Func_BaseConvert))

   ucDefine "Func:: iif(cond As Long, ByExpr TruePart As String, ByExpr FalsePart As String = '') As String", ucAddr(%uc_Func_IIF_Str)
   ucDefine "Func:: iif(cond As Long, ByExpr TruePart, ByExpr FalsePart = 0)", ucAddr(%uc_Func_IIF)
   ucDefine "Func: Inf() = 1/0"
   ucDefine "Func: NaN() = 0/0"

   ucDefine "Func:: Error(Message As String)", ucAddr(%uc_Raise_Error)
   ucDefine "Func:: ucAddr(index)", ucAddr(%uc_Func_ucAddr)
   ucDefine "Func:: ValueAtAddr(DataType As Dword, Address As Dword, Index As Long = 0) ~~ ValueAtAddr", ucAddr(%uc_Func_ValueAtAddr)
   ucDefine "Func:: BatchEval(ByHandle Var As Double, ByHandle VarArray As Double, ByHandle ResultArray As Double, " _
           +"Count As Long, ByExpr Expr As Double) As Void", ucAddr(%uc_Func_Batch_Eval)

   ucDefine "Var: NullStr As String At #", ucAddr(%uc_NullString)
   ucDefine "Func:: uCalc(Command As Long, TextArg As String = NullStr, MiscArg1 As Long = 0," _
           +"MiscArg2 As Long = 0, ReturnPtr As Long = 0, t As Long = 0) As Long", ucAddr(%uc_Func_uCalc)

   ucDefine "Func:: uCalcStr(Command As Long, TextArg As String = NullStr, MiscArg1 As Long = 0," _
           +"MiscArg2 As Long = 0, ReturnPtr As Long = 0, t As Long = 0) As String", ucAddr(%uc_Func_uCalcStr)

   ucDefine "Syntax: Precedence({Item}) ::= uCalc("+Str$(%uc_GetItemData)+", {Item}, 0, "+Str$(%uc_Precedence)+", 0, ~t)"

   ucDefine "Func:: uc_Loop(ByExpr DoCondition, ByExpr Expression As AnyType, ByExpr LoopCondition) As Void", ucAddr(%uc_Func_Loop)
   ucDefine "Func:: uc_For(ByHandle Counter As AnyType, Start, Finish, Step, ByExpr Expr As AnyType) As Void", ucAddr(%uc_Func_For)

   ucDefine "Func:: Asc(Character As String, Position As Long = 1) As Long", ucAddr(%uc_Func_Asc)
   ucDefine "Func:: Chr(Code As Long) As String", ucAddr(%uc_Func_Chr)

   ucDefine "Var: _Number As String = '([0-9]*\.)?[0-9]+(e[-+]?[0-9]+)?'"
   ucDefine "Var: _HexNumber As String = '([0-9a-z]*\.)?[0-9a-z]+(e[-+]?[0-9]+)?'"
   ucDefine "Var: _Alpha As String = '[a-z_][0-9a-z_]*'"
   ucDefine "Syntax: {Num:_Number}{Alpha:_Alpha} ::= {Num}*{Alpha}"
   ucDefine "Syntax: {'#b'}{Number:_Number} ::= ~Eval(BaseConvert('{Number}', 2))"
   ucDefine "Syntax: {'#o'}{Number:_Number} ::= ~Eval(BaseConvert('{Number}', 8))"
   ucDefine "Syntax: {'#h'}{Number:_HexNumber} ::= ~Eval(BaseConvert('{Number}', 16))"

   ucDefine "Const: uc_Define = " + Str$(%uc_Define)
   ucDefine "Syntax: ucDefine({Def}) ::= uCalc(uc_Define, {Def}, 0, 0, 0, ~t)"

   ucDefine "Syntax: Local([{' +'}]{Variable:'[^=, ]+'}[{etc}], {Expr}) ::= ~Eval_P(ucDefine('Var: {Variable} {etc}')) {Expr} ~Eval_P(ucRename('{Variable}', ''))"
   ucDefine "Syntax: Local({Variable1}, {OtherVariables}, {Expr}) ::= Local({Variable1}, Local({OtherVariables}, {Expr}))"

   ucDefine "Const: uc_DefineSyntax = " + Str$(%uc_DefineSyntax)
   ucDefine "Func:: SetSyntaxParams(Params As String, Expr As String, t As Dword = 0) As String", ucAddr(%uc_Func_SetSyntaxParams)
   ucDefineSyntax "Macro: {name} [{args:'\([^\)]*\)'}] = {replacement} ::= Syntax: ~Eval(SetSyntaxParams('{args}', '{name}{args} ::= {replacement}'))"

   ucDefine "Const: uc_GetItemData = " + Str$(%uc_GetItemData)
   ucDefine "Const: uc_SetItemData = " + Str$(%uc_SetItemData)
   ucDefine "Const: uc_SymbolName = " + Str$(%uc_SymbolName)
   ucDefine "Const: uc_Handle = " + Str$(%uc_Handle)
   ucDefine "Syntax: ucHandle({Item}) ::= uCalc(uc_GetItemData, {Item}, 0, uc_Handle, 0, ~t)"
   ucDefine "Syntax: ucRename({OldName}, {NewName})" _
           +"::= uCalc(uc_SetItemData, {NewName}, ucHandle({OldName}), uc_SymbolName, 0, ~t)"

   ' Arrays
   ucDefine("Const: uc_Address = " + Str$(%uc_Address))
   ucDefine("Const: uc_DataType = " + Str$(%uc_DataType))
   ucDefineSyntax("Address({Item}) ::= ~Eval(uCalc(uc_GetItemData, '{Item}', 0, uc_Address, 0, ~t))")
   ucDefineSyntax("DataType({Item})::= ~Eval(uCalc(uc_GetItemData, '{Item}', 0, uc_DataType, 0, ~t))")
   ucDefine("PassOnce ~~ Syntax: NextDef {etc:'.+'} ::= NextDef {etc}")

   ucDefineSyntax("Var: {'[ ]*'}{ArrayName:_Alpha} ({MaxIndex}) [{etc}]" _
   + "::= Count: {MaxIndex} ~~ Var: {ArrayName} {etc} ~~ NextDef ~~" _
   + "Syntax: {ArrayName} ({Index}) ::= ValueAtAddr(DataType({ArrayName}), Address({ArrayName}), {Index})")

   ' Assign Value to Variable
   ucDefine("Func:: SetVar(ByHandle Var As AnyType, ByHandle Value As String) As Void", ucAddr(%uc_SetVariableValueAnyType))
   ucDefine("Func:: SetVar(ByHandle Var As AnyType, ByHandle Value As Extended) As Void", ucAddr(%uc_SetVariableValueAnyType))
   ucDefine("Func:: SetVar(ByHandle Var As Double, ByHandle Value As Double) As Void", ucAddr(%uc_SetVariableValueDouble))
   ucDefine("Func:: SetVar(ByHandle Var As Extended, ByHandle Value As Extended) As Void", ucAddr(%uc_SetVariableValueExtended))
End Function
#EndIf

#EndIf
