Attribute VB_Name = "Module1"
Public Const MaxRow = 10
Public Const MaxCol = 5
Public ColumnName$(MaxCol)
Public CellEq$(), CellName$(MaxRow, MaxCol)

Dim Spreadsheet As Grid, UpdatingDepCells As Boolean
Dim CurrentCell As Long, DepIndex As Long, DepNext() As Long
Dim CellArray() As Double, FormulaPtr() As Long
Dim DepList() As Long, DepStart() As Long
Dim NewCellName$

Sub Main()
   ChDir App.Path
   Form1.Show
End Sub

Sub CellArrayValue(ByVal Expr As Long)
   Dim CellAddress As Long, iIndex As Long, TmpIndex As Long
   Dim CellRow As Long, CellCol As Long

   CellRow = ucParam(Expr, 1)
   CellCol = ucParam(Expr, 2)

   ReDim Preserve DepList(DepIndex + 2) As Long
   ReDim Preserve DepNext(DepIndex + 2) As Long
    
   CellAddress = (CellCol - 1) * MaxRow + CellRow
   ucReturn Expr, CellArray(CellAddress)
    
   If UpdatingDepCells = True Then Exit Sub
    
   If DepStart(CellAddress) = 0 Then
      If DepIndex = 0 Then DepIndex = DepIndex + 1
      DepStart(CellAddress) = DepIndex
      DepNext(DepIndex) = -1
   Else
      iIndex = DepStart(CellAddress)
      Do
         If DepList(iIndex) = CurrentCell Then Exit Sub
         If DepNext(iIndex) = -1 Then
            DepNext(iIndex) = DepIndex
            DepNext(DepIndex) = -1
            Exit Do
         End If
         TmpIndex = iIndex
         iIndex = DepNext(iIndex)
      Loop While DepNext(TmpIndex) <> -1
   End If
    
   DepList(DepIndex) = CurrentCell
   DepIndex = DepIndex + 1
End Sub

Sub SetCellValue(CellRow As Long, CellCol As Long, CellContent$)
   Dim EqPtr As Long, CellValue As Double
    
   CurrentCell = (CellCol - 1) * MaxRow + CellRow
    
   If Left$(CellContent$, 1) = "=" Then
      Call ProcessCellNames(Mid$(CellContent$, 2))
      EqPtr = ucParse(Mid$(CellContent$, 2))
      CellValue = ucEvaluate(EqPtr)
      FormulaPtr(CurrentCell) = EqPtr
      CellEq$(CurrentCell) = CellContent$
   Else
      CellValue = Val(CellContent$)
   End If

   UpdatingDepCells = True
   Call UpdateDepCells(CurrentCell, CellValue)
   UpdatingDepCells = False
End Sub

Sub UpdateDepCells(GridCell As Long, CellValue As Double)
   Dim iIndex As Long, DepCell As Long
    
   Spreadsheet.Col = (GridCell - 1) \ MaxRow + 1
   Spreadsheet.Row = GridCell - (Spreadsheet.Col - 1) * MaxRow
   Spreadsheet.Text = CellValue
   CellArray(GridCell) = CellValue
    
   iIndex = DepStart(GridCell)
   If iIndex <> 0 Then
      While iIndex <> -1
         DepCell = DepList(iIndex)
         CellValue = ucEvaluate(FormulaPtr(DepCell))
         Call UpdateDepCells(DepCell, CellValue)
         iIndex = DepNext(iIndex)
      Wend
   End If
End Sub

Sub SetColName(ColumnName$, ArrayCol As Long)
   ucDefineFunction ColumnName$ & "(x)=Cell(x," & Str$(ArrayCol) & " )"
End Sub

Sub SpreadSheetInit(Grid1 As Grid)
   Dim ArraySpace As Long
   Dim x As Long, Alpha As String
    
   Set Spreadsheet = Grid1
    
   ArraySpace = MaxRow * MaxCol
   ReDim CellArray(ArraySpace) As Double
   ReDim FormulaPtr(ArraySpace) As Long
   ReDim CellEq$(ArraySpace)
   ReDim DepStart(ArraySpace) As Long
    
   ucDefineFunction "Native: Cell(CellRow, CellCol)", AddressOf CellArrayValue
   uCalc uc_AddErrorHandler, 0, AddressOf MyErrorHandler
    
   Alpha = "ABCDEFGHIJK"
   Grid1.Col = 0
   For x = 1 To MaxRow
      Grid1.Row = x
      Grid1.Text = x
   Next
    
   Grid1.Row = 0
   For x = 1 To MaxCol
      Grid1.ColWidth(x) = Grid1.ColWidth(x) * 2
      Grid1.Col = x
      Grid1.Text = Mid$(Alpha, x, 1)
      ColumnName$(x) = Mid$(Alpha, x, 1)
      SetColName ColumnName$(x), x
   Next
End Sub

Function MyErrorHandler(ByVal t As Long) As Long
   If ucError(t) = uc_Err_Undefined_Identifier Then NewCellName$ = ucErrSymbol(t)
   MyErrorHandler = ucAbort
End Function

Sub ProcessCellNames(Eq$)
   Ignore = ucEval(Eq$)
   While Len(NewCellName$)
      ucDefineSyntax NewCellName$ + "::=" + Left$(NewCellName$, 1) & "(" & Mid$(NewCellName$, 2) & ")"
      NewCellName$ = ""
      Ignore = ucEval(Eq$)
   Wend
End Sub
